<script setup lang="ts">
    import { ref, onMounted, onBeforeUnmount } from "vue";
    import axios from "axios";
    import internAxios from "../functions/axios";
    import { getVersion } from "../functions/version";
    import { getBearer } from "../functions/bearer-auth";

    const currentAppVersion = ref("");
    const latestAppVersion = ref("");
    const latestAPIVersion = ref("");
    const currentAPIVersion = ref("");
    const scriptServerVersion = ref("");
    const scriptServerReachable = ref(false);

    function unsetValues() {
        currentAPIVersion.value = "Bitte einloggen";
        scriptServerVersion.value = "Bitte einloggen";
        scriptServerReachable.value = false;
    }

    onMounted(async () => {
        await reCalculateAvailability();
        await reCalculateVersions();
    });

    const availabilityTimeout = setInterval(async () => {
        await reCalculateAvailability();
    }, 2000);
    const versionTimeout = setInterval(async () => {
        await reCalculateVersions();
    }, 15000);

    onBeforeUnmount(() => {
        clearInterval(availabilityTimeout);
        clearInterval(versionTimeout);
    });

    async function reCalculateVersions() {
        currentAppVersion.value = "v" + (await getVersion());

        axios.get("https://gitlab.com/api/v4/projects/48424857/repository/tags").then((result) => {
            latestAppVersion.value = result.data[0].name ?? "";
        });

        axios
            .post("https://gitlab.com/api/graphql", {
                query: `
        query {
          project(fullPath:"mathezirkel/mathezirkel-app/backend") {
            repository {
              tree {
                lastCommit {
                  sha
                }
              }
            }
          }
        }
                    `,
            })
            .then((result) => {
                latestAPIVersion.value = result.data.data.project.repository.tree.lastCommit.sha ?? "";
            });
    }

    async function reCalculateAvailability() {
        const token = await getBearer();
        if (token != "EMPTYREPLACEMENTTOKEN") {
            internAxios
                .post("graphql", {
                    query: `
        query {
            apiVersion
            scriptServer {
                reachable
                version
            }
        }
                    `,
                })
                .then((result: any) => {
                    currentAPIVersion.value = result.data.data.apiVersion ?? "";
                    scriptServerVersion.value = result.data.data.scriptServer.version ?? "";
                    scriptServerReachable.value = result.data.data.scriptServer.reachable ?? false;
                })
                .catch(() => {
                    unsetValues();
                });
        } else {
            unsetValues();
        }
    }
</script>

<template>
    <v-col align-self="end" class="text-center">
        <p class="my-3">
            App Version:
            <span
                :style="{
                    color: currentAppVersion == latestAppVersion ? 'rgb(var(--v-theme-fg-green))' : 'rgb(var(--v-theme-fg-red))',
                }"
                >{{ currentAppVersion }}</span
            >
        </p>
        <p class="my-3">Latest App Version: {{ latestAppVersion }}</p>
        <p class="my-3">
            API Version:
            <span
                :style="{
                    color: currentAPIVersion == latestAPIVersion ? 'rgb(var(--v-theme-fg-green))' : 'rgb(var(--v-theme-fg-red))',
                }"
                >{{ currentAPIVersion }}</span
            >
        </p>
        <p class="my-3">Latest API Version: {{ latestAPIVersion }}</p>
        <p class="my-3">
            Scriptserver Version: {{ scriptServerVersion }}
            <span
                :style="{
                    color: scriptServerReachable ? 'rgb(var(--v-theme-fg-green))' : 'rgb(var(--v-theme-fg-red))',
                }"
            >
                {{ scriptServerReachable ? "(reachable)" : "(unreachable!)" }}
            </span>
        </p>
    </v-col>
</template>
